%define enable_japanese 1

# The original one doesn't work... because their system is broken
# I append man1 to mandir because their automake is broooken

%define configure  CFLAGS="${CFLAGS:-%optflags}" ; export CFLAGS ; CXXFLAGS="${CXXFLAGS:-%optflags}" ; export CXXFLAGS ; FFLAGS="${FFLAGS:-%optflags}" ; export FFLAGS ; %{?__libtoolize:[ -f configure.in ] && %{__libtoolize} --copy --force} ; ./configure %{_target_platform}  --prefix=%{_prefix} --exec-prefix=%{_exec_prefix} --bindir=%{_bindir} --datadir=%{_datadir}  --libdir=%{_libdir} --mandir=%{_mandir}/man1  --infodir=%{_infodir}

Summary: An X Window System based version of GNU Emacs.
Name: xemacs
Version: 21.1.12
Release: 3j3
License: GPL
Group: Applications/Editors
Source0: ftp://ftp.xemacs.org/pub/xemacs/xemacs-%{version}/xemacs-%{version}.tar.bz2
Source1:ftp://ftp.xemacs.org/pub/xemacs/xemacs-%{version}/xemacs-%{version}-info.tar.gz
Source2::ftp://ftp.xemacs.org/pub/xemacs/xemacs-%{version}/xemacs-%{version}-elc.tar.gz
Source3: ftp://ftp.xemacs.org/pub/xemacs/packages/xemacs-sumo-2000-05-24.tar.gz
Source5: xemacs-README.i386-pc-linux
Source6: xemacs.desktop
Source7: sh-script.el
Source8: sh-script.elc
Source9: xemacs-sitestart.el
Source10: ispell.el
Source11: ispell.elc

# Japanese stuff
Source20: Emacs.ad.Japanese
Source21: Editors.directory
Source22: dot-xemacs.el
Source23: dot-emacs

Patch1: xemacs-21.1.10-alpha.patch 
Patch2: xemacs-21.1.9-security-keystrokes.patch
Patch3: xemacs-noreturn.patch
Patch4: xemacs-21.1.10-ia64.patch
# Japanese patch
Patch10: xemacs-21.1.11-wnn.patch

Url: http://www.xemacs.org/
Buildroot: %{_tmppath}/%{name}-%{version}-root
%if %{enable_japanese}
BuildRequires: perl, Canna-devel, FreeWnn-devel, Wnn6-SDK-devel
%else
BuildRequires: perl
%endif
Requires: ctags
%if %{enable_japanese}
Requires: xemacs-sumo
%endif
Obsoletes: xemacs-extras xemacs-packages-el xemacs-packages
ExcludeArch: ia64

%description
XEmacs (and regular GNU Emacs, too) is a self-documenting,
customizable, extensible, real-time display editor.  XEmacs is
self-documenting because at any time you can type in control-h to find
out what your options are or to find out what a command does.  XEmacs
is customizable because you can change the definitions of XEmacs
commands to anything you want.  XEmacs is extensible because you can
write entirely new commands-programs in the Lisp language to be run
by Emacs' own Lisp interpreter.  XEmacs includes a real-time display,
which means that the text being edited is visible on the screen and is
updated very frequently (usually after every character or pair of
characters) as you type.

This XEmacs distribution consists of three rpms: xemacs (the main
portion, including the standard XEmacs binary which most people use),
xemacs-el (elisp sources, which you only need if you're going to
program with Lisp in XEmacs) and xemacs-info (optional information
about XEmacs)/

To use XEmacs, you'll need to install the XEmacs binary.  The xemacs
package includes the standard XEmacs binary that most people will use.
The XEmacs binary is dynamically linked, with both X11 and TTY
(ncurses) support, but without mule (MUlti-Lingual Emacs, the Asian
character set) support. A package with this will be added later.

%package el
Summary: The .el source files for XEmacs.
Group: Applications/Editors
Requires: xemacs = %{version}
%description el
Xemacs-el is not necessary to run XEmacs.  You'll only need to install
it if you're planning on incorporating some Lisp programming into your
XEmacs experience.

%package info
Summary: Information files for XEmacs.
Group: Applications/Editors
Requires: xemacs = %{version}
%description info
Install this package if you want the information files that are
distributed with the XEmacs text editor.

#%package mule
#Summary: The XEmacs binary with mule (MUlti-Lingual Emacs) support.
#Group: Applications/Editors
#Requires: xemacs = %{version}
#%description mule
#Xemacs-mule includes an XEmacs binary with support for MUlti-Lingual
#Emacs and the Asian character set. Install xemacs-mule (instead of
#xemacs) if you need to use Asian characters. Xemacs-mule is compiled
#with X11 support only, so you won't be able to use it in a TTY
#(ncurses) mode.

#%package noX
#Summary: An XEmacs binary without X11 support.
#Group: Applications/Editors
#Requires: xemacs = %{version}
#%description noX
#Xemacs-nox includes an XEmacs binary which will run XEmacs in console
#mode (with an ncurses interface). If you happen to like the XEmacs
#feature set a lot, but you either don't like X11 or can't use X11 all
#the time, this binary (instead of the standard XEmacs binary included
#in the xemacs package) is for you. It is *much* lighter than the
#standard X11 version of XEmacs, so you can enjoy a faster and smaller
#XEmacs.

#%package X11
#Summary: The XEmacs binary without ncurses support.
#Group: Applications/Editors
#Requires: xemacs = %{version}
#%description X11
#Xemacs-X11 includes an XEmacs binary you'll want to use instead of the
#binary included in the xemacs package, if you don't ever run XEmacs on
#the standard console (the ncurses interface). The advantage is that if
#you don't have the TTY support compiled in, you'll save some memory.

%prep

%setup -q -b 1 -b 2 
%patch1 -p1 -b .alpha
%patch3 -p1 -b .noreturn
#patch4 -p1 -b .ia64
%if %{enable_japanese}
%patch10 -p1 -b .wnn
%endif

rm -f xemacs-packages

%build
#fix for the alpha arch is to run libtoolize just in case
#libtoolize --copy --force
aclocal
autoconf
autoreconf
%if %{enable_japanese}
%configure --with-gpm=no --with-sound=none --with-pop --mail-locking=lockf \
    --with-clash-detection --debug=no --error-checking=none \
    --lockdir=/var/lock/xemacs --with-mule=yes \
    --with-menubars=lucid --with-scrollbars=lucid --with-dialogs=athena3d \
    --with-database=no \
    -with-xfs --with-xim=xlib \
    --with-canna --with-wnn6 \
    --site-libraries=/usr/lib \
    --site-includes=/usr/include/canna:/usr/include/wnn6
%else
%configure --with-gpm=no --with-sound=none --with-pop --mail-locking=lockf \
    --with-clash-detection --debug=no --error-checking=none \
    --lockdir=/var/lock/xemacs --with-mule=no \
    --with-menubars=lucid --with-scrollbars=lucid --with-dialogs=athena3d \
    --with-database=no
%endif

make

%install
rm -rf $RPM_BUILD_ROOT

# Their scripts are broooken
%makeinstall mandir=$RPM_BUILD_ROOT/%{_mandir}/man1

# These would clash with GNU Emacs
rm -f $RPM_BUILD_ROOT/usr/bin/{ctags,etags,rcs-checkin,b2m}
rm $RPM_BUILD_ROOT/%{_mandir}/man1/{etags.1,ctags.1}

cp %{SOURCE5} README.i386-pc-linux
mkdir -p $RPM_BUILD_ROOT/usr/lib/xemacs

tar -xzf %{SOURCE3} -C $RPM_BUILD_ROOT/usr/lib/xemacs

( 
  cd $RPM_BUILD_ROOT
  patch -p0 < %{PATCH2}
)

mkdir -p $RPM_BUILD_ROOT/usr/lib/xemacs/site-packages
find $RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages -name \*.pl -exec \
    perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g; \
		 s|/usr/local/bin/perl|/usr/bin/perl|g;" {} \;

cp %{SOURCE7} %{SOURCE8} $RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages/lisp/sh-script
cp %{SOURCE10} %{SOURCE11} $RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages/lisp/ispell


rm -f $RPM_BUILD_ROOT/%{_infodir}/dir
gzip -9f $RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages/info/*info*


#These crash with other packages
rm -f $RPM_BUILD_ROOT/%{_infodir}/info*
rm -f $RPM_BUILD_ROOT/%{_infodir}/standards*
rm -f $RPM_BUILD_ROOT/%{_infodir}/termcap*

install -m 755 -d $RPM_BUILD_ROOT/etc/X11/applnk/Editors/
install -m 644  %SOURCE6  $RPM_BUILD_ROOT/etc/X11/applnk/Editors/
install -m 644 %SOURCE9 $RPM_BUILD_ROOT/usr/share/xemacs-%{version}/lisp/site-start.el

%if %{enable_japanese}
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/lib/X11/ja/app-defaults
mkdir -p $RPM_BUILD_ROOT/etc/skel
install -m 644 %SOURCE20 $RPM_BUILD_ROOT/usr/X11R6/lib/X11/ja/app-defaults/Emacs
install -m 644 %SOURCE21 $RPM_BUILD_ROOT/etc/X11/applnk/Editors/.directory
install -m 644 %SOURCE22 $RPM_BUILD_ROOT/etc/skel/.xemacs.el
install -m 0644 %SOURCE23 $RPM_BUILD_ROOT/etc/skel/.emacs
%endif

# Lockdir
mkdir -p $RPM_BUILD_ROOT/var/lock/xemacs

# separate files

echo "%defattr(-,root,root)" > lispfiles
echo "%defattr(-,root,root)" > notlispfiles

find $RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages/  -type f -name "*.el" >> lispfiles
find $RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages/  -type f -not -name "*.el" >> notlispfiles
find $RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages -type d >> dirs

perl -pi -e "s|$RPM_BUILD_ROOT||" lispfiles
perl -pi -e "s|$RPM_BUILD_ROOT||" notlispfiles
perl -pi -e "s|$RPM_BUILD_ROOT||" dirs
perl -pi -e "s/^(.*)$/%dir \1/" dirs
%if %{enable_japanese}
perl -pi -e "s|/usr/lib/xemacs/xemacs-packages/lisp/edit-utils/man.elc||" notlispfiles
perl -pi -e "s|/usr/lib/xemacs/xemacs-packages/lisp/ispell/ispell.elc||" notlispfiles
perl -pi -e "s|/usr/lib/xemacs/xemacs-packages/lisp/sh-script/sh-script.elc||" notlispfiles
perl -pi -e "s|/usr/lib/xemacs/xemacs-packages/lisp/xemacs-base/time-stamp.elc||" notlispfiles 
%endif
cat dirs notlispfiles > mainpackagefiles

%post info
/sbin/install-info %{_infodir}/xemacs.info.gz %{_infodir}/dir
/sbin/install-info %{_infodir}/cl.info.gz %{_infodir}/dir
/sbin/install-info %{_infodir}/internals.info.gz %{_infodir}/dir
/sbin/install-info %{_infodir}/lispref.info.gz %{_infodir}/dir
/sbin/install-info %{_infodir}/new-users-guide.info.gz %{_infodir}/dir

%postun info
/sbin/install-info --delete %{_infodir}/xemacs.info.gz %{_infodir}/dir
/sbin/install-info --delete %{_infodir}/cl.info.gz %{_infodir}/dir
/sbin/install-info --delete %{_infodir}/internals.info.gz %{_infodir}/dir
/sbin/install-info --delete %{_infodir}/lispref.info.gz %{_infodir}/dir
/sbin/install-info --delete %{_infodir}/new-users-guide.info.gz %{_infodir}/dir

# permission
#find $RPM_BUILD_ROOT -type d | xargs chmod 0755

%files -f mainpackagefiles
%defattr(-, root, root)
%config /etc/X11/applnk/Editors/xemacs.desktop
%doc INSTALL README COPYING GETTING.GNU.SOFTWARE PROBLEMS CHANGES-beta
%doc etc/NEWS etc/MAILINGLISTS BUGS README.i386-pc-linux README.packages
%doc etc/TUTORIAL
%attr(1777, root, root) /var/lock/xemacs
%{_mandir}/*/*
/usr/bin/*
/usr/share/xemacs-%{version}
/usr/lib/xemacs-%{version}
%if %{enable_japanese}
/etc/X11/applnk/Editors/.directory
/usr/X11R6/lib/X11/ja/app-defaults/*
/etc/skel/.xemacs.el
/etc/skel/.emacs
%endif


%files el -f lispfiles
%defattr(-, root, root)

%files info 
%defattr(-, root, root)
%{_infodir}/*

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Sep 13 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- add /etc/skel/.emacs (move from emacs-cws)

* Wed Sep 13 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- add Require xemacs-sumo for japanese
- add /etc/skel/.xemacs.el

* Tue Aug 29 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add Japanese patches and a resource

* Thu Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- change locking mechanism to lockf

* Thu Aug 17 2000 Trond Eivind Glomsrd <teg@redhat.com>
- use ispell.el from GNU Emacs, which work better
  than the ones found at the xemacs ftp site or at the 
  author's site. Fixes bug #16071

* Sun Aug 06 2000 Trond Eivind Glomsrd <teg@redhat.com>
- 21.1.12 bugfix release
- removed security patch as it is now included
- gzip info packages in the package directory

* Tue Jul 18 2000 Trond Eivind Glomsrd <teg@redhat.com>
- 21.1.11
- upgrade(? - it wasn't specified) to sumo tarball from 2000-05-24
- add a sitestart.rl file, for configuration of info and spelling
- fixed the ownership of lots of package directories (#14197)
- disabled ia64 patch as they know have their own support...
- ... which doesn't work. Excludearch coming up.

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul 03 2000 Than Ngo <than@redhat.de>
- don't use xemac to compile some lisp-source in byte code 

* Sun Jul 02 2000 Trond Eivind Glomsrd <teg@redhat.com>
- include the files in the %%{_infodir}, not the directory

* Wed Jun 28 2000 Than Ngo <than@redhat.de>
- add xemacs-extras xemacs-packages-el xemacs-packages in obsoletes
  to resolse conflicts (#13120)
- add missing stuff (#13176)

* Tue Jun 27 2000 Trond Eivind Glomsrd <teg@redhat.com>
- don't specify -O0
- do it anyway for IA64

* Tue Jun 20 2000 Bill Nottingham <notting@redhat.com>
- build on ia64

* Tue Jun 20 2000 Trond Eivind Glomsrd <teg@redhat.com>
- override optflags, use -O0 to avoid compiler bugs
  (last build, actually)
- don't include some info files which clash with others

* Mon Jun 19 2000 Trond Eivind Glomsrd <teg@redhat.com>
- redid most of the spec file

* Mon Jun 19 2000 Trond Eivind Glomsrd <teg@redhat.com>
- build in the main tree
- disabled static package (it was partially disabled...)
- don't change ownership while installing
- updated some of the documentation (s/21.1.8/21.1.10/)
- don't build on IA64
- use %%{_mandir} instead of hardcoding /usr/share/man

* Mon May 29 2000 Ngo Than <than@redhat.de>
- update to 2.1.10 for 7.0
- fix permission
- put man pages in correct place
- fix xemacs to build with gcc-2.96 (thanks Jakub)

* Wed May 24 2000 Ngo Than <than@redhat.de>
- fix a security problem in key strokes.
- fix a permission problem. XEmacs doesn't set proper permissions for the slave PTY device.
- remove xemacs static

* Thu Mar 23 2000 Ngo Than <than@redhat.de>
- updated to 21.1.9

* Fri Feb 11 2000 Ngo Than <than@redhat.de>
- fixed Bug #7694, #9149

* Tue Jan 18 2000 Tim Powers <timp@redhat.com>
- bzipped sources to conserve space
- fixed so that alpha builds properly
- removed the --with-xface stuff.

* Wed Dec 1 1999 Tim Powers <timp@redhat.com>
- updated to 21.1.8
- gzip man pages
- now builds for alpha :)

* Thu Oct 21 1999 Cristian Gafton <gafton@redhat.com>
- include /var/lock/xemacs as the lockdir to make it stop whining

* Thu Aug 19 1999 Tim Powers <timp@redhat.com>
- fixed problem with dirs not being removed during uninstall

* Sun Jul 11 1999 Tim Powers <timp@redhat.com>
- updated to version 21.1.4
- added the elc and info src.
- modified spec as needed
- had a beer after building

* Fri May 14 1999 Cristian Gafton <gafton@redhat.com>
- version 21.1.2
- require ctags

* Wed Oct 14 1998 Michael Maher <mike@redhat.com>
- built pacakge for 5.2, didn't use a pre update. 

* Sat Apr 11 1998 Cristian Gafton <gafton@redhat.com>
- updated to 20.4
- new package xemacs-mule with mule support
- Changed spec file almost completely

* Fri Dec  5 1997 Otto Hammersmith <otto@redhat.com>
- refixed perl problem.
- added wmconfig

* Tue Dec  2 1997 Otto Hammersmith <otto@redhat.com>
- added changelog
- configure for ncurses
- removed sound support on i386
- moved buildroot to /var/tmp
